--   -------------------------------------------------- 
--   Generated by Enterprise Architect Version 7.1.832
--   Created On : Tuesday, 28 April, 2009 
--   DBMS       : SQL Server 2005 
--   -------------------------------------------------- 


--  Drop Foreign Key Constraints 
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id('[FK_CanTransitionTo_ToState]') AND OBJECTPROPERTY(id, 'IsForeignKey') = 1)
ALTER TABLE [CanTransitionTo] DROP CONSTRAINT [FK_CanTransitionTo_ToState]
;

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id('[FK_CanTransitionTo_FromState]') AND OBJECTPROPERTY(id, 'IsForeignKey') = 1)
ALTER TABLE [CanTransitionTo] DROP CONSTRAINT [FK_CanTransitionTo_FromState]
;

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id('[FK_MustHaveRole_CanTransitionTo]') AND OBJECTPROPERTY(id, 'IsForeignKey') = 1)
ALTER TABLE [MustHaveRole] DROP CONSTRAINT [FK_MustHaveRole_CanTransitionTo]
;

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id('[FK_MustHaveRole_Role]') AND OBJECTPROPERTY(id, 'IsForeignKey') = 1)
ALTER TABLE [MustHaveRole] DROP CONSTRAINT [FK_MustHaveRole_Role]
;

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id('[FK_State_StateMachine]') AND OBJECTPROPERTY(id, 'IsForeignKey') = 1)
ALTER TABLE [State] DROP CONSTRAINT [FK_State_StateMachine]
;

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id('[FK_StateMachineInstance_State]') AND OBJECTPROPERTY(id, 'IsForeignKey') = 1)
ALTER TABLE [StateMachineInstance] DROP CONSTRAINT [FK_StateMachineInstance_State]
;

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id('[FK_StateMachineInstance_StateMachine]') AND OBJECTPROPERTY(id, 'IsForeignKey') = 1)
ALTER TABLE [StateMachineInstance] DROP CONSTRAINT [FK_StateMachineInstance_StateMachine]
;

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id('[FK_Workflow_StateMachine]') AND OBJECTPROPERTY(id, 'IsForeignKey') = 1)
ALTER TABLE [Workflow] DROP CONSTRAINT [FK_Workflow_StateMachine]
;

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id('[FK_WorkflowInstance_StateMachineInstance]') AND OBJECTPROPERTY(id, 'IsForeignKey') = 1)
ALTER TABLE [WorkflowInstance] DROP CONSTRAINT [FK_WorkflowInstance_StateMachineInstance]
;


--  Drop Tables, Stored Procedures and Views 
IF EXISTS (SELECT * FROM dbo.SYSOBJECTS WHERE id = object_id('[CanTransitionTo]') AND  OBJECTPROPERTY(id, 'IsUserTable') = 1)
DROP TABLE [CanTransitionTo]
;

IF EXISTS (SELECT * FROM dbo.SYSOBJECTS WHERE id = object_id('[MustHaveRole]') AND  OBJECTPROPERTY(id, 'IsUserTable') = 1)
DROP TABLE [MustHaveRole]
;

IF EXISTS (SELECT * FROM dbo.SYSOBJECTS WHERE id = object_id('[Role]') AND  OBJECTPROPERTY(id, 'IsUserTable') = 1)
DROP TABLE [Role]
;

IF EXISTS (SELECT * FROM dbo.SYSOBJECTS WHERE id = object_id('[State]') AND  OBJECTPROPERTY(id, 'IsUserTable') = 1)
DROP TABLE [State]
;

IF EXISTS (SELECT * FROM dbo.SYSOBJECTS WHERE id = object_id('[StateMachine]') AND  OBJECTPROPERTY(id, 'IsUserTable') = 1)
DROP TABLE [StateMachine]
;

IF EXISTS (SELECT * FROM dbo.SYSOBJECTS WHERE id = object_id('[StateMachineInstance]') AND  OBJECTPROPERTY(id, 'IsUserTable') = 1)
DROP TABLE [StateMachineInstance]
;

IF EXISTS (SELECT * FROM dbo.SYSOBJECTS WHERE id = object_id('[Workflow]') AND  OBJECTPROPERTY(id, 'IsUserTable') = 1)
DROP TABLE [Workflow]
;

IF EXISTS (SELECT * FROM dbo.SYSOBJECTS WHERE id = object_id('[WorkflowInstance]') AND  OBJECTPROPERTY(id, 'IsUserTable') = 1)
DROP TABLE [WorkflowInstance]
;




--  Create Tables 
CREATE TABLE [CanTransitionTo] ( 
	[Id] int identity(1,1)  NOT NULL,
	[FromStateId] int NOT NULL,
	[ToStateId] int NOT NULL
)
;

CREATE TABLE [MustHaveRole] ( 
	[CanTransitionToId] int NOT NULL,
	[RoleId] int NOT NULL
)
;

CREATE TABLE [Role] ( 
	[Id] int NOT NULL,
	[Name] varchar(25) NOT NULL
)
;

CREATE TABLE [State] ( 
	[Id] int identity(1,1)  NOT NULL,
	[StateMachineId] int NOT NULL,
	[Name] varchar(25) NOT NULL,
	[IsInitialState] bit DEFAULT 0 NOT NULL,
	[IsFinalState] bit DEFAULT 0 NOT NULL
)
;

CREATE TABLE [StateMachine] ( 
	[Id] int identity(1,1)  NOT NULL,
	[Name] varchar(25) NOT NULL
)
;

CREATE TABLE [StateMachineInstance] ( 
	[Id] int identity(1,1)  NOT NULL,
	[StateMachineId] int NOT NULL,
	[CurrentState] int NOT NULL
)
;

CREATE TABLE [Workflow] ( 
	[Id] int NOT NULL,
	[Guid] uniqueidentifier NOT NULL
)
;

CREATE TABLE [WorkflowInstance] ( 
	[Id] int NOT NULL,
	[Guid] uniqueidentifier NOT NULL
)
;


--  Create Primary Key Constraints 
ALTER TABLE [CanTransitionTo] ADD CONSTRAINT [PK_CanTransitionTo] 
	PRIMARY KEY CLUSTERED ([Id])
;

ALTER TABLE [MustHaveRole] ADD CONSTRAINT [PK_MustHaveRole] 
	PRIMARY KEY CLUSTERED ([CanTransitionToId], [RoleId])
;

ALTER TABLE [Role] ADD CONSTRAINT [PK_Role] 
	PRIMARY KEY CLUSTERED ([Id])
;

ALTER TABLE [State] ADD CONSTRAINT [PK_State] 
	PRIMARY KEY CLUSTERED ([Id])
;

ALTER TABLE [StateMachine] ADD CONSTRAINT [PK_StateMachine] 
	PRIMARY KEY CLUSTERED ([Id])
;

ALTER TABLE [StateMachineInstance] ADD CONSTRAINT [PK_StateMachineInstance] 
	PRIMARY KEY CLUSTERED ([Id])
;

ALTER TABLE [Workflow] ADD CONSTRAINT [PK_Workflow] 
	PRIMARY KEY CLUSTERED ([Id])
;

ALTER TABLE [WorkflowInstance] ADD CONSTRAINT [PK_WorkflowInstance] 
	PRIMARY KEY CLUSTERED ([Id])
;


--  Create Indexes 
ALTER TABLE [CanTransitionTo]
	ADD CONSTRAINT [UQ_CanTransitionTo_Id] UNIQUE ([Id])
;

ALTER TABLE [Role]
	ADD CONSTRAINT [UQ_Role_Id] UNIQUE ([Id])
;

ALTER TABLE [Role]
	ADD CONSTRAINT [UQ_Role_Name] UNIQUE ([Name])
;

ALTER TABLE [State]
	ADD CONSTRAINT [UQ_State_Id] UNIQUE ([Id])
;

ALTER TABLE [State]
	ADD CONSTRAINT [UQ_State_Name] UNIQUE ([Name])
;

ALTER TABLE [StateMachine]
	ADD CONSTRAINT [UQ_StateMachine_Id] UNIQUE ([Id])
;

ALTER TABLE [StateMachine]
	ADD CONSTRAINT [UQ_StateMachine_Name] UNIQUE ([Name])
;

ALTER TABLE [StateMachineInstance]
	ADD CONSTRAINT [UQ_StateMachineInstance_Id] UNIQUE ([Id])
;

ALTER TABLE [Workflow]
	ADD CONSTRAINT [UQ_Workflow_Guid] UNIQUE ([Guid])
;

ALTER TABLE [WorkflowInstance]
	ADD CONSTRAINT [UQ_WorkflowInstance_Guid] UNIQUE ([Guid])
;


--  Create Foreign Key Constraints 
ALTER TABLE [CanTransitionTo] ADD CONSTRAINT [FK_CanTransitionTo_ToState] 
	FOREIGN KEY ([ToStateId]) REFERENCES [State] ([Id])
;

ALTER TABLE [CanTransitionTo] ADD CONSTRAINT [FK_CanTransitionTo_FromState] 
	FOREIGN KEY ([FromStateId]) REFERENCES [State] ([Id])
;

ALTER TABLE [MustHaveRole] ADD CONSTRAINT [FK_MustHaveRole_CanTransitionTo] 
	FOREIGN KEY ([CanTransitionToId]) REFERENCES [CanTransitionTo] ([Id])
;

ALTER TABLE [MustHaveRole] ADD CONSTRAINT [FK_MustHaveRole_Role] 
	FOREIGN KEY ([RoleId]) REFERENCES [Role] ([Id])
;

ALTER TABLE [State] ADD CONSTRAINT [FK_State_StateMachine] 
	FOREIGN KEY ([StateMachineId]) REFERENCES [StateMachine] ([Id])
;

ALTER TABLE [StateMachineInstance] ADD CONSTRAINT [FK_StateMachineInstance_State] 
	FOREIGN KEY ([CurrentState]) REFERENCES [State] ([Id])
;

ALTER TABLE [StateMachineInstance] ADD CONSTRAINT [FK_StateMachineInstance_StateMachine] 
	FOREIGN KEY ([StateMachineId]) REFERENCES [StateMachine] ([Id])
;

ALTER TABLE [Workflow] ADD CONSTRAINT [FK_Workflow_StateMachine] 
	FOREIGN KEY ([Id]) REFERENCES [StateMachine] ([Id])
;

ALTER TABLE [WorkflowInstance] ADD CONSTRAINT [FK_WorkflowInstance_StateMachineInstance] 
	FOREIGN KEY ([Id]) REFERENCES [StateMachineInstance] ([Id])
;
