﻿using System;
using WorkflowService.Model.DatabaseSpecific;
using WorkflowService.Model.EntityClasses;

namespace WorkflowService
{
    public class WorkflowServiceImpl : IWorkflowService
    {
        private DataAccessAdapter _adapter;

        public WorkflowServiceImpl()
        {
            _adapter = new DataAccessAdapter();
        }

        public WorkflowServiceImpl(string databaseServerName,
            string databaseName)
        {
            string connectionString = String.Format("data source={0};initial catalog={1};integrated security=SSPI;persist security info=False;packet size=4096",
                    databaseServerName, databaseName);
            _adapter = new DataAccessAdapter(connectionString);
        }



        #region IWorkflowService Members
        public void Terminate()
        {
            _adapter.CloseConnection();
        }
        
        public void SaveWorkflow(WorkflowEntity workflowEntity)
        {
            _adapter.SaveEntity(workflowEntity);
        }

        public void SaveWorkflowInstance(WorkflowInstanceEntity workflowInstanceEntity)
        {
            _adapter.SaveEntity(workflowInstanceEntity);
        }

        public WorkflowInstanceEntity FetchWorkflowInstance(Guid instanceGuid)
        {
            throw new NotImplementedException();
        }

        #endregion
    }
}
